## Introduction
The document enumerates the scenarios service is designed for, limitations of the service and onboarding guide. 


##  When to use Notification Service? 
When we have OSDU publishers of notifications and we want the notifications to get delivered to the external consumers outside the boundaries of OSDU with a secure,authenticated and authorized process.This way notification service creates a platform abstraction without exposing the infrastructure.


## How to use Notification Service. 
#### Prerequisite
Please verify that the topic you want to use exists. If now, follow [this](https://community.opengroup.org/osdu/platform/system/notification/-/blob/master/provider/notification-azure/PLAYBOOK_FOR_TOPIC_CREATION.md) guide to create one. 
 
#### 1. Publish to Service Bus Topic.
Using core-lib-azure [Publisher facade](https://community.opengroup.org/osdu/platform/system/lib/cloud/azure/os-core-lib-azure/-/blob/master/src/main/java/org/opengroup/osdu/azure/publisherFacade/MessagePublisher.java), you can publish the events.
Please refer to [this MR as a reference](https://community.opengroup.org/osdu/platform/system/storage/-/merge_requests/266) to understand the changes needed for your service to start using the Publisher Facade from core-lib.

#### 2. Steps to Subscribe
1. Register your subscriber with Register Service. You will need to expose two endpoints
	
	__Get Endpoint__: for a Handshake/challenge response. [Reference](https://community.opengroup.org/osdu/platform/system/register/-/blob/master/register-core/src/main/java/org/opengroup/osdu/register/api/test/SubscriberListenerApi.java#L52)
    
    __Post Endpoint__: for receiving notifications. [Reference](https://community.opengroup.org/osdu/platform/system/register/-/blob/master/register-core/src/main/java/org/opengroup/osdu/register/api/test/SubscriberListenerApi.java#L65)

2. For onboarding a service, you have to initiate a handshake, per data partition.
3. The authZ mechanism for the Get endpoint, isn't done by entitlement service.The secret used during the handshake should be used by the service to authorize the jwt.  
 
### Security compliance 
1. Please refrain from printing subscriber details in the logs like endpoints and secrets.  
 
### FAQs
1. __What is the difference between Notification v1 and v2?__ . 
Notification service v1 is having event grid push based model which will be deprecated due to performance implications of app gateway.
However v2 supports pull mechanism by using service bus as message broker.

2. __Does notification service provide filtering capability?__
Not today. 

3. __When should I create a topic vs using an existing one?__
If the nature of messages and subscribers overlap completely with an existing topic, re-use it.

4. __How to onboard new topics?__
We can add the topics in topics.json and get them registered for notification process.

5. __How to safely migrate from v1 to v2 with 0 downtime?__
Follow the [help doc](https://community.opengroup.org/osdu/platform/system/notification/-/blob/master/provider/notification-azure/docs/MIGRATION.md) for migration which ensure 0 downtime

6. __Does notification service provides DLQ handling and notification miss alerts?__
Not today.
