package org.opengroup.osdu.notification.provider.azure.messageBus.thread;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;
import org.opengroup.osdu.core.common.util.IServiceAccountJwtClient;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;

@RunWith(MockitoJUnitRunner.class)
public class ThreadDpsHeadersTest {
    @InjectMocks
    ThreadDpsHeaders threadDpsHeaders;

    @Mock
    IServiceAccountJwtClient serviceAccountJwtClient;

    @Before
    public void setup() {
        MockitoAnnotations.openMocks(ThreadDpsHeadersTest.this);
    }

    @Test
    public void setThreadContextTest() {
        try {
            threadDpsHeaders.setThreadContext("opendes", "ut", null);
            assertEquals(threadDpsHeaders.getHeaders().get("data-partition-id"),"opendes");
            assertEquals(threadDpsHeaders.getHeaders().get("correlation-id"),"ut");
        } catch (Exception e) {
            fail("didn't expect any exceptions here");
        }
    }

}
